import React, { MutableRefObject } from 'react';

declare type SwitchState = {
    offset: number;
    skipAnimation: boolean;
    dragStart: number | boolean;
    focus: boolean;
    value: boolean | null;
    labelWidth: string | number;
    handleWidth: string | number;
    dragged?: boolean;
};
declare type SwitchProps = {
    baseClass: string;
    wrapperClass: string;
    bsSize?: string;
    handleWidth: string | number;
    id?: string;
    labelWidth: string | number;
    onColor: string;
    offColor: string;
    onText: React.ReactNode;
    offText: React.ReactNode;
    labelText: React.ReactNode;
    inverse: boolean;
    animate: boolean;
    disabled: boolean;
    readonly: boolean;
    tristate: boolean;
    defaultValue: boolean;
    value?: boolean;
    onChange?: (sw: Switch, newValue: boolean | null) => {};
};
declare class Switch extends React.Component<SwitchProps, SwitchState> {
    static defaultProps: SwitchProps;
    elmOnHandle: MutableRefObject<HTMLSpanElement | null>;
    elmOffHandle: MutableRefObject<HTMLSpanElement | null>;
    elmLabel: MutableRefObject<HTMLDivElement | null>;
    constructor(props: SwitchProps);
    componentDidMount(): void;
    componentDidUpdate(nextProps: SwitchProps): void;
    _getValue(): boolean | null;
    value(val: string): boolean | null;
    _wrapperClasses(): string;
    _recalculateWidth(animate?: null | boolean): void;
    _updateContainerPosition(noAnimate?: boolean): void;
    _disableUserInput(): boolean;
    _handleOnClick(): void;
    _handleOffClick(): void;
    _handleKeyPress(e: React.KeyboardEvent): void;
    _handleLabelMouseDown(pageX: number): void;
    _handleLabelMouseMove(pageX: number): void;
    _handleLabelTouchEnd(): void;
    _handleLabelMouseUp(): void;
    _setFocus(): void;
    _setBlur(): void;
    _setValue(val: boolean | null): void;
    _fireStateChange(newValue: boolean | null): void;
    render(): JSX.Element;
    _renderOnHandle(): JSX.Element;
    _renderOffHandle(): JSX.Element;
    _renderLabel(): JSX.Element;
}

export { Switch };
